<script setup lang="ts">
import { useBuyStockStore } from '@/stores/buystock'
import type { BuyStock } from '@/types/BuyStock'
import { computed, nextTick, onMounted, reactive, ref } from 'vue'
import type { VForm } from 'vuetify/components'

const usebuyStockStore = useBuyStockStore()
const dialog = ref(false)
const form = ref(false)
const loading = ref(false)
const totalcost = ref()
const dialogDelete = ref(false)
const dialogEdit = ref(false)
const dialogEditCheck = ref(false)
const dialogEditImport = ref(false)
const dialogCheckBuyStock = ref(false)
const dialogImporBuyStock = ref(false)

const refForm = ref<VForm | null>(null)

const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Balance',
    key: 'balance',
    value: 'balance'
  },
  {
    title: 'Unit',
    key: 'unit',
    value: 'unit'
  },
  {
    title: 'Price/Unit',
    key: 'cost',
    value: 'cost'
  },
  {
    title: 'Total Price',
    key: 'totalcost',
    value: 'totalcost'
  },
  {
    title: 'Actions',
    key: 'actions',
    sortable: false
  }
]

function onSubmit() {}

// function callconvert()

// function convert(balance: number, cost: number) {
//   totalcost.value = balance * cost
//   return totalcost.value
// }
onMounted(() => {
  usebuyStockStore.getBuyStocks()
})
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    usebuyStockStore.clearForm()
  })
}
function closeDialogEdit() {
  dialogEdit.value = false
  nextTick(() => {
    usebuyStockStore.clearForm()
  })
}

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await usebuyStockStore.saveBuyStock()
  closeDialog()
}

async function saveEdit() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await usebuyStockStore.saveBuyStock()
  closeDialogEdit()
}

async function edit(item: BuyStock) {
  if (!item.id) return
  await usebuyStockStore.getBuyStock(item.id)
  dialogEdit.value = true
}
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    usebuyStockStore.clearForm()
  })
}
async function deleteItemConfirm() {
  await usebuyStockStore.deleteBuyStock()
  closeDelete()
}
async function deleteItem(item: BuyStock) {
  if (!item.id) return
  await usebuyStockStore.getBuyStock(item.id)
  dialogDelete.value = true
}
</script>

<template>
  <div>
    <v-data-table
      :headers="headers"
      :items="usebuyStockStore.searchBuyStock"
      class="custom-datatable"
    >
      <template v-slot:top>
        <v-toolbar style="background-color: #4b382a; height: auto" dark flat>
          <v-toolbar-title style="color: white">
            <v-text-field
              class="mr-4"
              prepend-inner-icon="mdi-magnify"
              v-model="usebuyStockStore.search"
              label="Search"
              style="height: 60px; margin-top: 4px"
            ></v-text-field>
          </v-toolbar-title>
          <v-divider class="mr-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited  Dialog -->
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn
                prepend-icon="mdi-plus"
                style="background-color: green; color: white; margin-right: 16px"
                v-bind="props"
              >
                Add Material
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Add Material</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="6" sm="6">
                        <v-text-field
                          v-model="usebuyStockStore.editedBuyStock.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="6" sm="6">
                        <v-text-field
                          v-model="usebuyStockStore.editedBuyStock.balance"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Balance (จำนวน)"
                          placeholder="Enter your balance"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="6" sm="6">
                        <v-combobox
                          label="Unit (หน่วย)"
                          :items="['Kilogram', 'Gram', 'Liter', 'Milliliter', 'piece']"
                          v-model="usebuyStockStore.editedBuyStock.unit"
                          variant="solo-filled"
                        ></v-combobox>
                      </v-col>
                      <v-col cols="6" sm="6">
                        <v-text-field
                          v-model="usebuyStockStore.editedBuyStock.cost"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Cost (ต้นทุน)"
                          placeholder="Cost"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- Delete Dialog -->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card class="center-card" elevation="5">
              <v-icon
                icon="mdi-alert-circle-outline"
                size="110px"
                style="margin-top: 5%; color: rgba(255, 151, 4, 1)"
              ></v-icon>
              <v-card-text>Are you sure you want to delete this item?</v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn
                  style="background-color: rgba(223, 50, 46, 1); color: white"
                  rounded="lg"
                  @click="closeDelete"
                  ><span style="color: white">Cancel</span></v-btn
                >
                <v-btn
                  style="background-color: rgba(45, 133, 219, 1); color: white"
                  rounded="lg"
                  @click="deleteItemConfirm"
                  ><span style="color: white">OK</span></v-btn
                >
                <v-spacer></v-spacer>
              </v-card-actions>
              <div style="margin-bottom: 5%"></div>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" color="blue-accent-4" class="me-2" @click="edit(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" color="red-accent-4" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
    </v-data-table>
  </div>
  <v-dialog v-model="dialogEdit" max-width="500px">
    <v-card>
      <v-card-title>
        <v-icon end icon="mdi-file-document-edit-outline" size="30px"></v-icon
        ><span class="text-h5"> Edit BuyStock </span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
          <v-container>
            <v-row>
              <v-col cols="12">
                <v-text-field
                  v-model="usebuyStockStore.editedBuyStock.name"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="Name"
                ></v-text-field>
              </v-col>

              <v-col cols="6" sm="6">
                <v-text-field
                  v-model="usebuyStockStore.editedBuyStock"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Min"
                  placeholder="Enter your min"
                ></v-text-field>
              </v-col>
              <v-col cols="6" sm="6">
                <v-combobox
                  label="Unit"
                  :items="['Kilogram', 'Gram', 'Liter', 'Milliliter', 'piece']"
                  v-model="usebuyStockStore.editedBuyStock.unit"
                  variant="solo-filled"
                ></v-combobox>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="closeDialogEdit"> Close </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="saveEdit()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<style>
.center-card {
  display: flex;
  justify-content: center;
  align-items: center;
}
.custom-datatable {
  & th {
    background-color: rgba(174, 167, 160, 1);
    color: white;
    font-weight: bold;
  }

  & tbody tr:nth-child(even) {
    background-color: rgba(244, 238, 226, 1);
  }

  & tbody tr:nth-child(odd) {
    background-color: rgba(234, 227, 217, 1);
  }
}

.sub-datatable {
  & th {
    color: black;
    font-weight: bold;
  }

  background-color: rgb(253, 241, 227);
}

.headers-datatable {
  & th {
    color: black;
    font-weight: bold;
  }
}

.overviewBuyStock {
  font-family: 'Kanit';
  font-size: 55px;
  font-weight: bold;
  color: white;
  text-align: left;
}

.subDialog {
  font-family: 'Kanit';
  font-size: 30px;
  color: white;
  text-align: center;
  background-color: rgba(114, 87, 42, 1);
}

.showStatusDialog {
  font-family: 'Kanit';
  font-size: 30px;
  color: white;
  text-align: center;
}
</style>
